SystemOrganization addCategory: #'Pier-Tests-Core'!
SystemOrganization addCategory: #'Pier-Tests-Kernel'!
SystemOrganization addCategory: #'Pier-Tests-Structure'!
SystemOrganization addCategory: #'Pier-Tests-Document'!
SystemOrganization addCategory: #'Pier-Tests-Command'!
SystemOrganization addCategory: #'Pier-Tests-Utilities'!

TestCase subclass: #PRObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Core'!

PRObjectTest subclass: #PRCommandTest
	instanceVariableNames: 'kernel structure context command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

PRCommandTest subclass: #PRAddCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRAddCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRAddCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRAddCommand! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testAddChild
	| child |
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure childrenDecoration
		includes: self command name).

	child := self structure childrenDecoration
		at: self command name.
	self assert: child name = self command name.
	self assert: child species = self command type! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testAddConflict
	self
		shouldnt: [ self command execute ]
		raise: PRConflictingNameError.
	self
		should: [ self command execute ]
		raise: PRConflictingNameError
		do: [ :ex | self assert: self command structure = ex structure ]! !

!PRAddCommandTest methodsFor: 'testing-utilties' stamp: 'lr 3/9/2006 11:31'!
testUniqueTitle
	20 timesRepeat: [
		self
			shouldnt: [
				self structure addChild: (PRPage named: (self command
					uniqueName: 'foo' in: self structure)) ]
			raise: PRConflictingNameError ].
	#( 'foo' 'foo 2' 'foo 9' 'foo 10' 'foo 11' 'foo 20' ) do: [ :each |
		self assert: (self structure childrenDecoration includes: each) ]! !

!PRCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRCommand! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass context: self context! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
command
	^ command ifNil: [ command := self actualInstance ]! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
context
	^ context ifNil: [ context := self contextInstance ]! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
contextInstance
	^ PRContext kernel: self kernel structure: self structure! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ self command! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ]! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
kernelInstance
	^ PRKernel new
		root: ((PRPage named: 'root')
			addChild: (PRPage named: 'folder');
			addChild: (self structure);
			yourself);
		yourself! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
structure
	^ structure ifNil: [ structure := self structureInstance ]! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
structureInstance
	^ PRPage named: 'command'! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAnswer
	self assert: self command answer isNil.
	self command answer: self context.
	self assert: self command answer = self context! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testContext
	self assert: self command context notNil.
	self command context: self context.
	self assert: self command context = self context! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsLogged
	self assert: self command isLogged! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsQuick
	self deny: self command isQuick! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsView
	self deny: self command isView! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testKernel
	self assert: self command kernel = self kernel! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testRoot
	self assert: self command root = self kernel root! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testStructure
	self assert: self command structure = self structure! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testTimestamp
	| stamp |
	self assert: self command timestamp isNil.
	self command timestamp: (stamp := TimeStamp now).
	self assert: self command timestamp = stamp! !

!PRCommandTest methodsFor: 'testing-utilities' stamp: 'lr 9/25/2006 08:26'!
testUniqueName
	20 timesRepeat: [
		self
			shouldnt: [
				self structure addChild: (PRPage named: (self command
					uniqueName: 'foo' in: self structure)) ]
			raise: PRConflictingNameError ].! !

!PRCommandTest methodsFor: 'testing-utilities' stamp: 'lr 9/25/2006 08:29'!
testUniqueNameDoesNotAddDecoration
	self command uniqueName: 'foo' in: self structure.
	self structure 
		decorationOfClass: self structure childrenDecorationClass 
		ifAbsent: [ ^ self ].
	self assert: self structure hasChildren! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 3/21/2006 18:43'!
testValidateChild
	self
		should: [
			self command
				validateChild: (PRPage named: 'folder')
				in: self context root ]
		raise: PRConflictingNameError
		do: [ :ex | self assert: self context root = ex structure ].
	self
		shouldnt: [
			self command
				validateChild: (PRPage named: 'zork')
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateChild: (self context root childrenDecoration at: 'folder')
				in: self context root ]
		raise: PRConflictingNameError! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 9/25/2006 08:31'!
testValidateChildDoesNotAddDecoration
	self command
		validateChild: (PRPage named: 'zork')
		in: self context root.
	self structure
		decorationOfClass: self structure childrenDecoration
		ifAbsent: [ ^ self ].
	self assert: self structure hasChildren! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 3/21/2006 18:43'!
testValidateChildNamed
	self
		should: [
			self command
				validateChild: PRPage new
				named: 'folder'
				in: self context root ]
		raise: PRConflictingNameError
		do: [ :ex | self assert: self context root = ex structure ].
	self
		shouldnt: [
			self command
				validateChild: PRPage new
				named: 'zork'
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateChild: (self context root childrenDecoration
					at: 'folder')
				named: 'zork'
				in: self context root ]
		raise: PRConflictingNameError! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 3/9/2006 11:31'!
testValidateName
	self
		shouldnt: [
			self command
				validateName: 'zork'
				of: PRPage new
				in: self context root ]
		raise: PRConflictingNameError.
	self
		should: [
			self command
				validateName: 'folder'
				of: PRPage new
				in: self context root ]
		raise: PRConflictingNameError
		do: [ :ex | self assert: self context root = ex structure ].
	self
		shouldnt: [
			self command
				validateName: 'zork'
				of: (self context root childrenDecoration at: 'folder')
				in: self context root ]
		raise: PRConflictingNameError.
	self
		shouldnt: [
			self command
				validateName: 'folder'
				of: (self context root childrenDecoration at: 'folder')
				in: self context root ]
		raise: PRConflictingNameError! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 3/9/2006 11:31'!
testValidateNesting
	self
		shouldnt: [
			self command
				validateNestingOf: self context root
				in: PRPage new ]
		raise: PRInvalidNestingError.
	self
		shouldnt: [
			self command
				validateNestingOf: PRPage new
				in: self context root ]
		raise: PRInvalidNestingError! !

PRCommandTest subclass: #PREditCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PREditCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PREditCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PREditCommand! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 3/9/2006 11:31'!
testTitleChanged
	| title |
	self command
		write: (title := 'foo')
		using: PRStructure descriptionTitle.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure title = title! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 3/9/2006 11:31'!
testTitleInitialized
	self assert: (self command readUsing: PRStructure descriptionTitle) = self structure title! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 3/9/2006 11:31'!
testTitleUnchanged
	| title |
	title := self structure title.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure title = title! !

PREditCommandTest subclass: #PREditFileCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PREditFileCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PREditFileCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
structureInstance
	^ PRFile named: 'command'! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 3/9/2006 11:31'!
testFileChanged
	| file |
	self command
		write: (file := MAFileModel new
			contents: 'foobar';
			filename: 'test.txt';
			mimetype: 'text/plain';
			yourself)
		using: PRFile descriptionFile.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure file = file! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 3/9/2006 11:31'!
testFileInitialized
	self assert: (self command readUsing: PRFile descriptionFile) = self structure file! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 3/9/2006 11:31'!
testFileUnchanged
	| file |
	file := self structure file.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure file = file! !

PREditCommandTest subclass: #PREditPageCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PREditPageCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PREditPageCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
structureInstance
	^ PRPage named: 'command'! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 3/9/2006 11:31'!
testContentsChanged
	| contents |
	self command
		write: (contents := '!!foo')
		using: PRPage descriptionContents.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure contents = contents! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 3/9/2006 11:31'!
testContentsInitialized
	self assert: (self command readUsing: PRPage descriptionContents) = self structure contents! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 3/9/2006 11:31'!
testContentsUnchanged
	| contents |
	contents := self structure contents.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure contents = contents! !

PRCommandTest subclass: #PRLocationCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

PRLocationCommandTest subclass: #PRCopyCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRCopyCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRCopyCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRCopyCommand! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testCopy
	self command name: 'foo'.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure parent childrenDecoration
		includes: 'foo').
	self assert: (self structure parent childrenDecoration
		at: 'foo') = self command answer structure! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testCopyIntoChild
	self command
		name: 'foo';
		target: self structure.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure childrenDecoration
		includes: 'foo').
	self assert: (self structure childrenDecoration
		at: 'foo') = self command answer structure! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testCopyIntoRoot
	self command
		name: 'foo';
		target: self command root.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self command root childrenDecoration
		includes: 'foo').
	self assert: (self command root childrenDecoration
		at: 'foo') = self command answer structure! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 4/10/2006 14:52'!
testCopyTitle
	self command name: 'foo'; execute.
	self assert: (self structure title) = 'Command'.
	self assert: (self structure parent childrenDecoration
		at: 'foo') title = 'Foo'! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	super testInitialized.
	self assert: self structure name , ' copy' = self command name! !

!PRLocationCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRLocationCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRLocationCommand! !

!PRLocationCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testConflict
	self command name: 'folder'.
	self
		should: [ self command execute ]
		raise: PRConflictingNameError
		do: [ :ex | self assert: self kernel root = ex structure ]! !

!PRLocationCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	self assert: self command target = self structure parent! !

PRLocationCommandTest subclass: #PRMoveCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRMoveCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRMoveCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRMoveCommand! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	super testInitialized.
	self assert: self structure name = self command name! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testMove
	self command target: self command root.
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self command root childrenDecoration
		includes: self structure name)! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testMoveIntoChild
	self command target: self structure.
	self
		should: [ self command execute ]
		raise: PRInvalidNestingError.
	self assert: (self structure parent childrenDecoration
		includes: self structure name)! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testMoveIntoFolder
	self command target: (self command root childrenDecoration
		at: 'folder').
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self deny: (self command root childrenDecoration
		includes: self structure name).
	self assert: ((self command root childrenDecoration
		at: 'folder') childrenDecoration
			includes: self structure name)! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRename
	self command name: 'foo'.
	self
		shouldnt: [ self command execute ]
		raise: PRConflictingNameError.
	self deny: (self structure parent childrenDecoration
		includes: 'command').
	self assert: (self structure parent childrenDecoration
		includes: 'foo')! !

!PRMoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRenameExisting
	self command name: 'folder'.
	self
		should: [ self command execute ]
		raise: PRConflictingNameError.
	self assert: (self structure parent childrenDecoration
		includes: 'command').
	self assert: (self structure parent childrenDecoration
		includes: 'folder')! !

PRCommandTest subclass: #PRRemoveCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRRemoveCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRRemoveCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRRemoveCommand! !

!PRRemoveCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsQuick
	self assert: self command isQuick! !

!PRRemoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRemoveLeaf
	self assert: (self kernel root childrenDecoration
		includes: self structure name).
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure parent isNil.
	self deny: (self kernel root childrenDecoration
		includes: self structure name)! !

!PRRemoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRemoveNode
	self structure
		addChild: (PRPage named: 'foo');
		addChild: (PRPage named: 'bar').
	self assert: (self kernel root childrenDecoration
		includes: self structure name).
	self
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure parent isNil.
	self deny: (self kernel root childrenDecoration
		includes: self structure name)! !

!PRRemoveCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testRemoveRoot
	context := self context
		structure: self kernel root
		command: self actualClass new.
	self
		should: [ self command ]
		raise: Error! !

PRCommandTest subclass: #PRViewCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRViewCommandTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRViewCommandTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRViewCommand! !

!PRViewCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsLogged
	self deny: self command isLogged! !

!PRViewCommandTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsView
	self assert: self command isView! !

!PRViewCommandTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testSimple
	self
		should: [ self command execute ]
		raise: Error! !

PRObjectTest subclass: #PRContextTest
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Kernel'!

!PRContextTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRContextTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRContext! !

!PRContextTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
context
	^ context ifNil: [ context := self contextInstance ]! !

!PRContextTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ self context! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 3/9/2006 11:31'!
testGotoStructure
	| current currentStructure currentCommand next nextStructure |
	currentStructure := self context structure.
	currentCommand := self context command.
	current := self context.

	nextStructure := self context structure childrenDecoration at: 'folder'.
	next := self context structure: nextStructure.

	self deny: current = next.

	self assert: current structure = currentStructure.
	self assert: current command = currentCommand.

	self assert: next structure = nextStructure.
	self assert: next command isView! !

!PRContextTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialState
	self assert: self context structure = self context kernel root.
	self assert: self context command isView! !

PRObjectTest subclass: #PRDecoratedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRDecoratedTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRDecoratedTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRDecorated! !

!PRDecoratedTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
decorationWithPriority: anInteger
	^ PRMockDecoration new
		priority: anInteger;
		yourself! !

!PRDecoratedTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAddDecoration
	| mock1 mock2 index1 index2 |
	mock1 := self decorationWithPriority: 10.
	mock2 := self decorationWithPriority: -5.

	self assert: (self instance addDecoration: mock1) = mock1.
	self assert: self instance = mock1 decorated.
	self assert: (self instance decorations includes: mock1).

	self assert: (self instance addDecoration: mock2) = mock2.
	self assert: self instance = mock2 decorated.
	self assert: (self instance decorations includes: mock2).

	index1 := self instance decorations indexOf: mock1.
	index2 := self instance decorations indexOf: mock2.
	self assert: index1 > index2.

	self should: [ self instance addDecoration: mock1 ] raise: Error.
	self should: [ self instance addDecoration: mock2 ] raise: Error.
	self assert: (self instance decorations includes: mock2).
	self assert: (self instance decorations includes: mock2)! !

!PRDecoratedTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAddDecorationIfPresent
	| mock1 mock2 index1 index2 |
	mock1 := self decorationWithPriority: 10.
	mock2 := self decorationWithPriority: -5.

	self assert: (self instance
		addDecoration: mock1
		ifPresent: [ :value | self assert: false ]) = mock1.
	self assert: self instance = mock1 decorated.
	self assert: (self instance decorations includes: mock1).

	self assert: (self instance
		addDecoration: mock2
		ifPresent: [ :value | self assert: false ]) = mock2.
	self assert: self instance = mock2 decorated.
	self assert: (self instance decorations includes: mock2).

	index1 := self instance decorations indexOf: mock1.
	index2 := self instance decorations indexOf: mock2.
	self assert: index1 > index2.

	self assert: (self instance
		addDecoration: mock1
		ifPresent: [ :value | nil ]) isNil.
	self assert: (self instance
		addDecoration: mock2
		ifPresent: [ :value | nil ]) isNil.
	self assert: (self instance decorations includes: mock1).
	self assert: (self instance decorations includes: mock2)! !

!PRDecoratedTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyDecorations
	| decoration copiedInstance copiedDecoration |
	decoration := self instance addDecoration: (self decorationWithPriority: SmallInteger minVal).
	copiedInstance := self instance copy.
	copiedDecoration := copiedInstance decorations first.

	self deny: self instance == copiedInstance.
	self deny: decoration == copiedDecoration.

	self assert: self instance decorations first = decoration.
	self assert: self instance = decoration decorated.

	self assert: copiedInstance decorations first = copiedDecoration.
	self assert: copiedInstance = copiedDecoration decorated! !

!PRDecoratedTest methodsFor: 'testing-querying' stamp: 'lr 3/9/2006 11:31'!
testDecorationOfClass
	| mock |
	self should: [ self instance decorationOfClass: PRMockDecoration ] raise: Error.
	self instance addDecoration: (mock := self decorationWithPriority: 1).
	self assert: (self instance decorationOfClass: PRMockDecoration) = mock! !

!PRDecoratedTest methodsFor: 'testing-querying' stamp: 'lr 3/9/2006 11:31'!
testDecorationOfClassIfAbsent
	| mock |
	self assert: (self instance decorationOfClass: PRMockDecoration ifAbsent: [ nil ]) isNil.
	self instance addDecoration: (mock := self decorationWithPriority: 1).
	self assert: (self instance decorationOfClass: PRMockDecoration) = mock! !

!PRDecoratedTest methodsFor: 'testing-enumerating' stamp: 'lr 3/9/2006 11:31'!
testDecorationsDo
	| first second |
	self instance
		addDecoration: (first := self decorationWithPriority: SmallInteger minVal);
		addDecoration: (second := self decorationWithPriority: SmallInteger maxVal).
	self instance decorationsDo: [ :each |
		(first notNil and: [ second notNil and: [ each = first ] ])
			ifTrue: [ first := nil ].
		(first isNil and: [ second notNil and: [ each = second ] ])
			ifTrue: [ second := nil ] ].
	self assert: first isNil.
	self assert: second isNil! !

!PRDecoratedTest methodsFor: 'testing-enumerating' stamp: 'lr 3/9/2006 11:31'!
testDecorationsDoOwnerDo
	| instance first second |
	instance := self instance
		addDecoration: (first := self decorationWithPriority: SmallInteger minVal);
		addDecoration: (second := self decorationWithPriority: SmallInteger maxVal);
		yourself.
	self instance
		decorationsDo: [ :each |
			(first notNil and: [ instance notNil and: [ second notNil and: [ each = first ] ] ])
				ifTrue: [ first := nil ].
			(first isNil and: [ instance isNil and: [ second notNil and: [ each = second ] ] ])
				ifTrue: [ second := nil ] ]
		ownerDo: [ :each |
			self assert: first isNil.
			self assert: second notNil.
			self assert: instance notNil.
			instance := nil ].
	self assert: first isNil.
	self assert: second isNil.
	self assert: instance isNil! !

!PRDecoratedTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testInitialized
	self assert: (self instance decorations isKindOf: Collection)! !

!PRDecoratedTest methodsFor: 'testing-removing' stamp: 'lr 3/9/2006 11:31'!
testRemoveDecoration
	| mock1 mock2 |
	self instance
		addDecoration: (mock1 := self decorationWithPriority: 1);
		addDecoration: (mock2 := self decorationWithPriority: 2).

	self assert: (self instance removeDecoration: mock1) = mock1.
	self deny: (self instance decorations includes: mock1).
	self assert: (self instance decorations includes: mock2).

	self assert: (self instance removeDecoration: mock2) = mock2.
	self deny: (self instance decorations includes: mock1).
	self deny: (self instance decorations includes: mock2).

	self should: [ self instance removeDecoration: mock2 ] raise: Error! !

!PRDecoratedTest methodsFor: 'testing-removing' stamp: 'lr 3/9/2006 11:31'!
testRemoveDecorationIfAbsent
| mock1 mock2 |
	self instance
		addDecoration: (mock1 := self decorationWithPriority: 1);
		addDecoration: (mock2 := self decorationWithPriority: 2).

	self assert: (self instance removeDecoration: mock1 ifAbsent: [ nil ]) = mock1.
	self deny: (self instance decorations includes: mock1).
	self assert: (self instance decorations includes: mock2).

	self assert: (self instance removeDecoration: mock2 ifAbsent: [ nil ]) = mock2.
	self deny: (self instance decorations includes: mock1).
	self deny: (self instance decorations includes: mock2).

	self assert: (self instance removeDecoration: mock2 ifAbsent: [ nil ]) isNil! !

PRDecoratedTest subclass: #PRStructureTest
	instanceVariableNames: 'root folder child structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

PRStructureTest subclass: #PRFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRFileTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRFileTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRFile! !

PRStructureTest subclass: #PRPageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRPageTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRPageTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRPage! !

!PRPageTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ super actualInstance
		contents: '!!A Title
-A simple List-Element.';
		yourself! !

!PRPageTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testContents
	self structure contents: nil.
	self assert: self structure contents = ''.

	self structure contents: ''.
	self assert: self structure contents = ''.

	self structure contents: 'Foo'.
	self assert: self structure contents = 'Foo'! !

!PRPageTest methodsFor: 'testing-fulltext' stamp: 'lr 3/9/2006 11:31'!
testFullTextSearchCaseInsensitive
	| matches |
	matches := PRFullTextSearch from: self root find: 'title' caseSensitive: false.
	self assert: (matches size = 1 and: [ matches first = self structure ]).
	matches := PRFullTextSearch from: self root find: 'Title' caseSensitive: false.
	self assert: (matches size = 1 and: [ matches first = self structure ]).

	matches := PRFullTextSearch from: self root find: 'list-element' caseSensitive: false.
	self assert: (matches size = 1 and: [ matches first = self structure ]).
	matches := PRFullTextSearch from: self root find: 'List-Element' caseSensitive: false.
	self assert: (matches size = 1 and: [ matches first = self structure ])! !

!PRPageTest methodsFor: 'testing-fulltext' stamp: 'lr 3/9/2006 11:31'!
testFullTextSearchCaseSensitive
	| matches |
	matches := PRFullTextSearch from: self root find: 'title' caseSensitive: true.
	self assert: (matches size = 0).
	matches := PRFullTextSearch from: self root find: 'Title' caseSensitive: true.
	self assert: (matches size = 1 and: [ matches first = self structure ]).

	matches := PRFullTextSearch from: self root find: 'list-element' caseSensitive: true.
	self assert: (matches size = 0).
	matches := PRFullTextSearch from: self root find: 'List-Element' caseSensitive: true.
	self assert: (matches size = 1 and: [ matches first = self structure ])! !

!PRStructureTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRStructure! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass named: 'structure'! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
child
	^ child! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 10/30/2006 16:41'!
childInstance
	^ PRPage named: 'child'! !

!PRStructureTest methodsFor: 'utilities' stamp: 'lr 10/30/2006 16:21'!
enumerator: aVisitor gives: aCollection
	| children |
	children := aVisitor collect: #name.
	self
		assert: children asSet = aCollection asSet
		description: children asString , ' should be ' , aCollection asString
		resumable: true! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
folder
	^ folder! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 10/30/2006 16:41'!
folderInstance
	^ PRPage named: 'folder'! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ structure! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
root
	^ root! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 10/30/2006 16:41'!
rootInstance
	^ PRPage named: 'root'! !

!PRStructureTest methodsFor: 'running' stamp: 'lr 3/9/2006 11:31'!
setUp
	root := self rootInstance.
	folder := self folderInstance.
	child := self childInstance.
	structure := self actualInstance.

	self root addChild: self folder.
	self folder addChild: self child.
	self folder addChild: self structure! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
structure
	^ structure! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testCanBeChildOf
	PRStructure withAllConcreteClassesDo: [ :each |
		self
			shouldnt: [ self structure canBeChildOf: each new ]
			raise: Error ]! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testCanBeParentOf
	PRStructure withAllConcreteClassesDo: [ :each |
		self
			shouldnt: [ self structure canBeParentOf: each new ]
			raise: Error ]! !

!PRStructureTest methodsFor: 'testing-children' stamp: 'lr 10/30/2006 16:18'!
testChildren
	self enumerator: self root enumerator gives: #( 'folder' ).
	self enumerator: self root enumerator with gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all gives: #( 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator with all gives: #( 'root' 'folder' 'child' 'structure' ).

	self enumerator: self root enumerator hidden gives: #( 'folder' ).
	self enumerator: self root enumerator with hidden gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all hidden gives: #( 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator with all hidden gives: #( 'root' 'folder' 'child' 'structure' ).
	
	self enumerator: self root enumerator everything gives: #( 'root' 'folder' 'child' 'structure' )! !

!PRStructureTest methodsFor: 'testing-children' stamp: 'lr 10/30/2006 16:18'!
testChildrenHiddenFolder
	self folder addDecoration: PRHider new.

	self enumerator: self root enumerator gives: #( ).
	self enumerator: self root enumerator with gives: #( 'root' ).
	self enumerator: self root enumerator all gives: #( ).
	self enumerator: self root enumerator with all gives: #( 'root' ).

	self enumerator: self root enumerator hidden gives: #( 'folder' ).
	self enumerator: self root enumerator with hidden gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all hidden gives: #( 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator with all hidden gives: #( 'root' 'folder' 'child' 'structure' ).
	
	self enumerator: self root enumerator everything gives: #( 'root' 'folder' 'child' 'structure' )! !

!PRStructureTest methodsFor: 'testing-children' stamp: 'lr 10/30/2006 16:17'!
testChildrenHiddenRoot
	self root addDecoration: PRHider new.

	self enumerator: self root enumerator gives: #( ).
	self enumerator: self root enumerator with gives: #( ).
	self enumerator: self root enumerator all gives: #( ).
	self enumerator: self root enumerator with all gives: #( ).

	self enumerator: self root enumerator hidden gives: #( 'folder' ).
	self enumerator: self root enumerator with hidden gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all hidden gives: #( 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator with all hidden gives: #( 'root' 'folder' 'child' 'structure' ).
	
	self enumerator: self root enumerator everything gives: #( 'root' 'folder' 'child' 'structure' )! !

!PRStructureTest methodsFor: 'testing-children' stamp: 'lr 10/30/2006 16:21'!
testChildrenHiddenStructure
	self structure addDecoration: PRHider new.

	self enumerator: self root enumerator gives: #( 'folder' ).
	self enumerator: self root enumerator with gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all gives: #( 'folder' 'child' ).
	self enumerator: self root enumerator with all gives: #( 'root' 'folder' 'child' ).

	self enumerator: self root enumerator hidden gives: #( 'folder' ).
	self enumerator: self root enumerator with hidden gives: #( 'root' 'folder' ).
	self enumerator: self root enumerator all hidden gives: #( 'folder' 'child' 'structure' ).
	self enumerator: self root enumerator with all hidden gives: #( 'root' 'folder' 'child' 'structure' ).
	
	self enumerator: self root enumerator everything gives: #( 'root' 'folder' 'child' 'structure' )! !

!PRStructureTest methodsFor: 'testing-copying' stamp: 'lr 3/21/2006 18:43'!
testCopyChildren
	| folderCopy childCopy structureCopy |
	folderCopy := self folder copy.
	childCopy := folderCopy childrenDecoration at: 'child'.
	structureCopy := folderCopy childrenDecoration at: 'structure'.

	self deny: self folder = folderCopy.
	self deny: self child = childCopy.
	self deny: self structure = structureCopy.

	self assert: self folder parent = self root.
	self assert: self child parent = self folder.
	self assert: self structure parent = self folder.

	self assert: folderCopy parent isNil.
	self assert: childCopy parent = folderCopy.
	self assert: structureCopy parent = folderCopy! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasChildren
	self assert: self root hasChildren.
	self assert: self folder hasChildren.
	self deny: self child hasChildren.
	self deny: self structure hasChildren! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasParent
	self deny: self root hasParent.
	self assert: self folder hasParent.
	self assert: self child hasParent.
	self assert: self structure hasParent! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/21/2006 18:43'!
testIncompleteLookup
	| lookup |
	lookup := PRIncompletePathLookup
		start: self root
		path: '/folder/zork'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'zork'.

	lookup := PRIncompletePathLookup
		start: self structure
		path: '../structure/bar'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'bar'! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testIncompleteLookupIgnored
	| lookup |
	lookup := PRIncompletePathLookup
		start: self folder
		path: '../folder/child/foo/bar'.
	self assert: lookup key = self child.
	self assert: lookup value = 'foo'.

	lookup := PRIncompletePathLookup
		start: self folder
		path: 'foo/bar'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'foo'! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/21/2006 18:43'!
testIncompleteLookupTitle
	| lookup |
	lookup := PRIncompletePathLookup
		start: self root
		path: '/Folder/Zork'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'Zork'.

	lookup := PRIncompletePathLookup
		start: self structure
		path: '../Structure/Bar'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'Bar'! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsAncestorOf
	self assert: (self root isAncestorOf: self root).
	self assert: (self root isAncestorOf: self folder).
	self assert: (self root isAncestorOf: self child).
	self assert: (self root isAncestorOf: self structure).

	self deny: (self folder isAncestorOf: self root).
	self assert: (self folder isAncestorOf: self folder).
	self assert: (self folder isAncestorOf: self child).
	self assert: (self folder isAncestorOf: self structure).

	self deny: (self child isAncestorOf: self root).
	self deny: (self child isAncestorOf: self folder).
	self assert: (self child isAncestorOf: self child).
	self deny: (self child isAncestorOf: self structure).

	self deny: (self structure isAncestorOf: self root).
	self deny: (self structure isAncestorOf: self folder).
	self deny: (self structure isAncestorOf: self child).
	self assert: (self structure isAncestorOf: self structure)! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testIsRoot
	self assert: self root isRoot.
	self deny: self folder isRoot.
	self deny: self child isRoot.
	self deny: self structure isRoot! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testLevel
	self assert: self root level = 1.
	self assert: self folder level = 2.
	self assert: self child level = 3.
	self assert: self structure level = 3! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupComposed
	self assert: (PRPathLookup start: self child path: '../child/..') = self folder.
	self assert: (PRPathLookup start: self child path: '../child/../') = self folder.

	self assert: (PRPathLookup start: self child path: '../structure/..') = self folder.
	self assert: (PRPathLookup start: self child path: '../structure/../') = self folder.

	self assert: (PRPathLookup start: self child path: '../structure/../child') = self child.
	self assert: (PRPathLookup start: self child path: '../structure/../child/') = self child.

	self assert: (PRPathLookup start: self child path: '../structure/../structure') = self structure.
	self assert: (PRPathLookup start: self child path: '../structure/../structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 15:26'!
testLookupComposedTitle
	self assert: (PRPathLookup start: self child path: '../Child/..') = self folder.
	self assert: (PRPathLookup start: self child path: '../Child/../') = self folder.

	self assert: (PRPathLookup start: self child path: '../Structure/..') = self folder.
	self assert: (PRPathLookup start: self child path: '../Structure/../') = self folder.

	self assert: (PRPathLookup start: self child path: '../Structure/../child') = self child.
	self assert: (PRPathLookup start: self child path: '../structure/../Child/') = self child.

	self assert: (PRPathLookup start: self child path: '../Structure/../structure') = self structure.
	self assert: (PRPathLookup start: self child path: '../structure/../Structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupEmpty
	self assert: (PRPathLookup start: self root path: '') = self root.
	self assert: (PRPathLookup start: self folder path: '') = self folder.
	self assert: (PRPathLookup start: self child path: '') = self child.
	self assert: (PRPathLookup start: self structure path: '') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 15:25'!
testLookupError
	self should: [ PRPathLookup start: self root path: 'unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'unknown/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folDer' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'fOlder/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folder/unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'folder/unknown/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folder/unknown/unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'folder/unknown/unknown/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folder/instance/unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'folder/instance/unknown/' ] raise: Error! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupParent
	self assert: (PRPathLookup start: self root path: '..') = self root.
	self assert: (PRPathLookup start: self root path: '../') = self root.

	self assert: (PRPathLookup start: self folder path: '..') = self root.
	self assert: (PRPathLookup start: self folder path: '../') = self root.

	self assert: (PRPathLookup start: self child path: '..') = self folder.
	self assert: (PRPathLookup start: self child path: '../') = self folder.

	self assert: (PRPathLookup start: self structure path: '..') = self folder.
	self assert: (PRPathLookup start: self structure path: '../') = self folder! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupParentParent
	self assert: (PRPathLookup start: self root path: '../..') = self root.
	self assert: (PRPathLookup start: self root path: '../../') = self root.

	self assert: (PRPathLookup start: self folder path: '../..') = self root.
	self assert: (PRPathLookup start: self folder path: '../../') = self root.

	self assert: (PRPathLookup start: self child path: '../..') = self root.
	self assert: (PRPathLookup start: self child path: '../../') = self root.

	self assert: (PRPathLookup start: self structure path: '../..') = self root.
	self assert: (PRPathLookup start: self structure path: '../..') = self root! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupParsing
	self assert: (PRPathLookup new stream: 'abc' readStream; readNext) = 'abc'.
	self assert: (PRPathLookup new stream: 'abc/' readStream; readNext) = 'abc'.

	self assert: (PRPathLookup new stream: 'abc/def' readStream; readNext) = 'abc'.
	self assert: (PRPathLookup new stream: 'abc/def/' readStream; readNext) = 'abc'.

	self assert: (PRPathLookup new stream: 'abc' readStream; readNext; readNext) = ''.
	self assert: (PRPathLookup new stream: 'abc/' readStream; readNext; readNext) = ''.

	self assert: (PRPathLookup new stream: 'abc/def' readStream; readNext; readNext) = 'def'.
	self assert: (PRPathLookup new stream: 'abc/def/' readStream; readNext; readNext) = 'def'! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupRelative
	self assert: (PRPathLookup start: self structure path: '../structure') = self structure.
	self assert: (PRPathLookup start: self structure path: '../structure/') = self structure.

	self assert: (PRPathLookup start: self structure path: '../../folder') = self folder.
	self assert: (PRPathLookup start: self structure path: '../../folder/') = self folder.

	self assert: (PRPathLookup start: self structure path: '../../folder/structure') = self structure.
	self assert: (PRPathLookup start: self structure path: '../../folder/structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 15:24'!
testLookupRelativeTitle
	self assert: (PRPathLookup start: self structure path: '../Structure') = self structure.
	self assert: (PRPathLookup start: self structure path: '../Structure/') = self structure.

	self assert: (PRPathLookup start: self structure path: '../../Folder') = self folder.
	self assert: (PRPathLookup start: self structure path: '../../Folder/') = self folder.

	self assert: (PRPathLookup start: self structure path: '../../Folder/Structure') = self structure.
	self assert: (PRPathLookup start: self structure path: '../../Folder/Structure/') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 11:31'!
testLookupRoot
	self assert: (PRPathLookup start: self root path: '/') = self root.
	self assert: (PRPathLookup start: self root path: '/folder') = self folder.
	self assert: (PRPathLookup start: self root path: '/folder/child') = self child.
	self assert: (PRPathLookup start: self root path: '/folder/structure') = self structure.

	self assert: (PRPathLookup start: self structure path: '/') = self root.
	self assert: (PRPathLookup start: self structure path: '/folder') = self folder.
	self assert: (PRPathLookup start: self structure path: '/folder/child') = self child.
	self assert: (PRPathLookup start: self structure path: '/folder/structure') = self structure! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 3/9/2006 15:24'!
testLookupRootTitle
	self assert: (PRPathLookup start: self root path: '/Folder') = self folder.
	self assert: (PRPathLookup start: self root path: '/Folder/Child') = self child.
	self assert: (PRPathLookup start: self root path: '/Folder/Structure') = self structure.

	self assert: (PRPathLookup start: self structure path: '/Folder') = self folder.
	self assert: (PRPathLookup start: self structure path: '/Folder/Child') = self child.
	self assert: (PRPathLookup start: self structure path: '/Folder/Structure') = self structure! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self assert: self root name = 'root'.
	self assert: self folder name = 'folder'.
	self assert: self child name = 'child'.
	self assert: self structure name = 'structure'! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testParent
	self assert: self root parent = nil.
	self assert: self folder parent = root.
	self assert: self child parent = folder.
	self assert: self structure parent = folder! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testParents
	self assert: self root parents size = 1.
	self assert: self root parents first = self root.

	self assert: self folder parents size = 2.
	self assert: self folder parents first = self root.
	self assert: self folder parents second = self folder.

	self assert: self child parents size = 3.
	self assert: self child parents first = self root.
	self assert: self child parents second = self folder.
	self assert: self child parents third = self child.

	self assert: self structure parents size = 3.
	self assert: self structure parents first = self root.
	self assert: self structure parents second = self folder.
	self assert: self structure parents third = self structure! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 3/9/2006 11:31'!
testReferenceEmpty
	self assert: (PRPathReference from: self root to: self root) = '/'.

	self assert: (PRPathReference from: self folder to: self folder) = ''.
	self assert: (PRPathReference from: self child to: self child) = ''.
	self assert: (PRPathReference from: self structure to: self structure) = ''! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 3/9/2006 11:31'!
testReferenceError
	self should: [ PRPathReference from: self root to: PRPage new ] raise: Error.
	self should: [ PRPathReference from: self folder to: PRPage new ] raise: Error.
	self should: [ PRPathReference from: self child to: PRPage new ] raise: Error.
	self should: [ PRPathReference from: self structure to: PRPage new ] raise: Error.

	self should: [ PRPathReference from: PRPage new to: self root  ] raise: Error.
	self should: [ PRPathReference from: PRPage new to: self folder ] raise: Error.
	self should: [ PRPathReference from: PRPage new to: self child ] raise: Error.
	self should: [ PRPathReference from: PRPage new to: self structure ] raise: Error! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 3/9/2006 11:31'!
testReferenceParent
	self assert: (PRPathReference from: self folder to: self root) = '..'.
	self assert: (PRPathReference from: self child to: self folder) = '..'.
	self assert: (PRPathReference from: self structure to: self folder) = '..'.

	self assert: (PRPathReference from: self child to: self root) = '../..'.
	self assert: (PRPathReference from: self structure to: self root) = '../..'! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 3/9/2006 11:31'!
testReferenceRelative
	self assert: (PRPathReference from: self child to: self structure) = '../structure'.
	self assert: (PRPathReference from: self structure to: self child) = '../child'! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 3/9/2006 11:31'!
testReferenceRoot
	self assert: (PRPathReference to: self root) = '/'.
	self assert: (PRPathReference to: self folder) = '/folder'.
	self assert: (PRPathReference to: self child) = '/folder/child'.
	self assert: (PRPathReference to: self structure) = '/folder/structure'.

	self assert: (PRPathReference from: self root to: self root) = '/'.
	self assert: (PRPathReference from: self root to: self folder) = '/folder'.
	self assert: (PRPathReference from: self root to: self child) = '/folder/child'.
	self assert: (PRPathReference from: self root to: self structure) = '/folder/structure'! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testRoot
	self assert: self root root = self root.
	self assert: self folder root = self root.
	self assert: self child root = self root.
	self assert: self structure root = self root! !

PRObjectTest subclass: #PRDecorationTest
	instanceVariableNames: 'decorated decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

PRDecorationTest subclass: #PRChildrenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRChildrenTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRChildren! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
firstChildInstance
	^ PRPage named: 'child1'! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
secondChildInstance
	^ PRPage named: 'child2'! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 3/9/2006 11:31'!
testAdd
	| child1 child2 |
	child1 := self firstChildInstance.
	self assert: (self decoration add: child1) = child1.
	self assert: self decorated = child1 parent.

	child2 := self secondChildInstance.
	self assert: (self decoration add: child2) = child2.
	self assert: self decorated = child2 parent! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 3/9/2006 11:31'!
testAddInvalid
	| plain empty duplicate parented |
	self decoration add: self firstChildInstance.

	plain := PRPage new.
	empty := PRPage named: ''.
	duplicate := PRPage named: self firstChildInstance name.
	parented := self secondChildInstance
		parent: self firstChildInstance;
		yourself.

	self should: [ self decoration add: plain ] raise: Error.
	self should: [ self decoration add: empty ] raise: Error.
	self should: [ self decoration add: duplicate ] raise: Error.
	self should: [ self decoration add: parented ] raise: Error! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAt
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration at: child1 name) = child1.
	self assert: (self decoration at: child2 name) = child2.
	self should: [ self decoration at: 'zork' ] raise: Error! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAtIfAbsent
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration at: child1 name ifAbsent: [ nil ]) = child1.
	self assert: (self decoration at: child2 name ifAbsent: [ nil ]) = child2.
	self assert: (self decoration at: 'zork' ifAbsent: [ nil ]) isNil! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAtIfPresent
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration
		at: child1 name
		ifPresent: [ :val | val ]) = child1.
	self assert: (self decoration
		at: child2 name
		ifPresent: [ :val | 'zork' ]) = 'zork'.
	self assert: (self decoration
		at: 'zork'
		ifPresent: [ :val | self assert: false ]) isNil! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testIncludes
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration includes: child1 name).
	self assert: (self decoration includes: child2 name).
	self deny: (self decoration includes: 'zork')! !

!PRChildrenTest methodsFor: 'testing-testing' stamp: 'lr 9/25/2006 08:20'!
testIsEmpty
	self assert: self decoration isEmpty.
	self decoration add: self firstChildInstance.
	self deny: self decoration isEmpty! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 3/9/2006 11:31'!
testRemove
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).
	self assert: (self decoration remove: child1) = child1.
	self assert: (self decoration remove: child2) = child2.
	self assert: (self decoration isEmpty)! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 3/9/2006 11:31'!
testRemoveInvalid
	self decoration add: self firstChildInstance.

	self should: [ self decoration remove: self firstChildInstance ] raise: Error.
	self should: [ self decoration remove: self secondChildInstance ] raise: Error! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 9/25/2006 08:18'!
testRemoveLast
	"Tests that the children decoration is properly removed if the last child has been removed from the decoration."

	| child |
	self decoration
		add: (child := self firstChildInstance).
	self decoration
		remove: child.
	self decorated
		decorationOfClass: self actualClass
		ifAbsent: [ ^ self ].
	self assert: false! !

!PRDecorationTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRDecoration! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass new! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
decorated
	^ decorated! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
decoratedInstance
	^ PRPage new! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
decoration
	^ decoration! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ decoration! !

!PRDecorationTest methodsFor: 'running' stamp: 'lr 3/9/2006 11:31'!
setUp
	decorated := self decoratedInstance.
	decoration := self actualInstance.
	decorated addDecoration: decoration! !

!PRDecorationTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyDecorated
	| ownerCopy decorationCopy |
	ownerCopy := self decorated copy.
	decorationCopy := ownerCopy decorations first.

	self deny: self decorated == ownerCopy.
	self deny: self decorated == decorationCopy.

	self assert: self decorated decorations size = 1.
	self assert: self decorated decorations first = self decoration.
	self assert: self decorated = self decoration decorated.

	self assert: ownerCopy decorations size = 1.
	self assert: ownerCopy decorations first = decorationCopy.
	self assert: ownerCopy = decorationCopy decorated! !

!PRDecorationTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyDecoration
	| decorationCopy |
	decorationCopy := self decoration copy.

	self deny: self decoration == decorationCopy.
	self assert: self decoration = decorationCopy.
	self assert: self decoration decorated = self decorated.
	self assert: decorationCopy decorated isNil! !

!PRDecorationTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testDecorated
	self assert: self decoration decorated = self decorated! !

!PRDecorationTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testPriority
	self assert: self decoration priority isNumber! !

!PRDecorationTest methodsFor: 'testing-utilities' stamp: 'lr 9/25/2006 08:23'!
testRemove
	self decoration remove.
	self assert: self decoration decorated isNil.
	self decorated 
		decorationOfClass: self actualClass
		ifAbsent: [ ^ self ].
	self assert: false! !

PRDecorationTest subclass: #PRHiderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRHiderTest class methodsFor: 'testing' stamp: 'lr 9/25/2006 08:21'!
isAbstract
	^ false! !

!PRHiderTest methodsFor: 'private' stamp: 'lr 9/25/2006 08:21'!
actualClass
	^ PRHider! !

PRObjectTest subclass: #PRDocumentItemTest
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

PRDocumentItemTest subclass: #PRAnchorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRAnchorTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRAnchorTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRAnchor! !

!PRAnchorTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualName
	self deny: (self actualClass with: 'foo') = (self actualClass with: 'bar')! !

!PRAnchorTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self instance name: 'zork'.
	self assert: self instance name = 'zork'! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := '@name'.
	tree := PRDocument new
		add: (PRAnchor with: 'name');
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseMultiple
	| wiki tree |
	wiki := '@one
@two

@tree'.
	tree := PRDocument new
		add: (PRAnchor with: 'one');
		add: (PRAnchor with: 'two');
		add: PRParagraph new;
		add: (PRAnchor with: 'tree');
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSpaces
	| wiki tree |
	wiki := '@one two'.
	tree := PRDocument new
		add: (PRAnchor with: 'one two');
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRAnchorTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWith
	instance := self actualClass with: 'test'.
	self assert: self instance name = 'test'! !

PRDocumentItemTest subclass: #PRDocumentGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRDocumentGroupTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRDocumentGroup! !

!PRDocumentGroupTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAdd
	self instance add: self fooInstance.
	self assert: self instance children size = 1.
	self assert: self instance children first = self fooInstance.

	self instance add: self barInstance.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance! !

!PRDocumentGroupTest methodsFor: 'testing-adding' stamp: 'lr 3/9/2006 11:31'!
testAddAll
	self instance addAll: self foobarInstances.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance! !

!PRDocumentGroupTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyChildren
	self instance addAll: self foobarInstances.
	self assert: self instance children = self instance copy children.
	self deny: self instance children == self instance copy children.
	self instance children
		with: self instance copy children
		do: [ :a :b | self assert: a = b. self deny: a == b ]! !

!PRDocumentGroupTest methodsFor: 'testing-testing' stamp: 'lr 3/20/2006 19:08'!
testHasChildren
	self deny: self instance hasChildren.
	self instance add: self fooInstance.
	self assert: self instance hasChildren! !

!PRDocumentGroupTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testText
	self instance addAll: self foobarInstances.
	self assert: self instance text = 'foobar'! !

!PRDocumentGroupTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWith
	instance := self actualClass with: self fooInstance.
	self assert: instance children size = 1.
	self assert: instance children first = self fooInstance! !

!PRDocumentGroupTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWithAll
	instance := self actualClass withAll: self foobarInstances.
	self assert: instance children size = 2.
	self assert: instance children first = self fooInstance.
	self assert: instance children second = self barInstance! !

PRDocumentGroupTest subclass: #PRDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRDocumentTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRDocumentTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRDocument! !

!PRDocumentTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := String new.
	tree := PRDocument new.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

PRDocumentGroupTest subclass: #PRHeaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRHeaderTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRHeaderTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRHeader! !

!PRHeaderTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualLevel
	self deny: (self actualClass new level: 1) = (self actualClass new level: 2)! !

!PRHeaderTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self instance level: 3.
	self assert: self instance level = 3! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLevel1
	| wiki tree |
	wiki := '!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 1;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLevel2
	| wiki tree |
	wiki := '!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 2;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLevel3
	| wiki tree |
	wiki := '!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 3;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLevel4
	| wiki tree |
	wiki := '!!!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 4;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLevel5
	| wiki tree |
	wiki := '!!!!!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 5;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLevel6
	| wiki tree |
	wiki := '!!!!!!!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 6;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 5/29/2006 09:12'!
testParseNested
	| wiki tree |
	wiki := '!!!!Hello *Link*'.
	tree := PRDocument new
		add: (PRHeader new
			level: 2;
			add: (PRText with: 'Hello ');
			add: (PRInternalLink new
				reference: 'Link';
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHeaderTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWithAllLevel
	instance := self actualClass withAll: self foobarInstances level: 3.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance.
	self assert: self instance level = 3! !

!PRHeaderTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWithLevel
	instance := self actualClass with: self fooInstance level: 2.
	self assert: self instance children size = 1.
	self assert: self instance children first = self fooInstance.
	self assert: self instance level = 2! !

PRDocumentGroupTest subclass: #PRLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

PRLinkTest subclass: #PRExternalLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRExternalLinkTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRExternalLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRExternalLink! !

!PRExternalLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'http://www.lukas-renggli.ch'! !

!PRExternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 12:06'!
testTitle
	self instance reference: 'http://www.lukas-renggli.ch'.
	self assert: self instance title = 'http://www.lukas-renggli.ch'! !

!PRExternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testUrl
	self instance reference: 'http://www.lukas-renggli.ch'.
	self assert: self instance url = 'http://www.lukas-renggli.ch'! !

PRExternalLinkTest subclass: #PRIsbnLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRIsbnLinkTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRIsbnLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRIsbnLink! !

!PRIsbnLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'isbn:1590594916'! !

!PRIsbnLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 12:17'!
testTitle
	self instance reference: 'isbn:1590594916'.
	self assert: self instance title = 'ISBN 1590594916'! !

!PRIsbnLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testUrl
	self instance reference: 'isbn:1590594916'.
	self assert: self instance url = 'http://www.amazon.com/exec/obidos/ISBN=1590594916'! !

PRExternalLinkTest subclass: #PRMailLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRMailLinkTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRMailLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRMailLink! !

!PRMailLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'renggli@iam.unibe.ch'! !

!PRMailLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 11:45'!
testTitle
	super testTitle.
	self instance reference: 'renggli@iam.unibe.ch'.
	self assert: self instance title = 'renggli@iam.unibe.ch'! !

!PRMailLinkTest methodsFor: 'testing-accessing' stamp: 'lr 5/24/2006 11:14'!
testUrl
	self instance reference: 'renggli@iam.unibe.ch'.
	self assert: (self instance url beginsWith: 'mailto:').
	self assert: self instance url ~= 'mailto:renggli@iam.unibe.ch'! !

PRExternalLinkTest subclass: #PRRfcLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRRfcLinkTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRRfcLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRRfcLink! !

!PRRfcLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'rfc:1896'! !

!PRRfcLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 12:17'!
testTitle
	self instance reference: 'rfc:1896'.
	self assert: self instance title = 'RFC 1896'! !

!PRRfcLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testUrl
	self instance reference: 'rfc:1896'.
	self assert: self instance url = 'http://www.faqs.org/rfcs/rfc1896.html'! !

PRLinkTest subclass: #PRInternalLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRInternalLinkTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRInternalLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRInternalLink! !

!PRInternalLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	^ 'Page'! !

!PRInternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAnchor
	self instance anchor: 'zork'.
	self assert: self instance anchor = 'zork'.
	self assert: self instance hasAnchor! !

!PRInternalLinkTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualAnchor
	self deny: (self actualClass new anchor: 'foo'; yourself) = ((self actualClass new) anchor: 'bar'; yourself)! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseAnchored
	| wiki tree |
	wiki := '*' , self referenceString , '@Anchor*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				anchor: 'Anchor';
				yourself);
			yourself);
		yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseAnchoredEmbedded
	| wiki tree |
	wiki := '+' , self referenceString , '@Anchor+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				anchor: 'Anchor';
				embedded: true;
				yourself);
			yourself);
		yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEverything
	| wiki tree |
	wiki := '*Alias>' , self referenceString , '@Anchor*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText with: 'Alias');
				reference: self referenceString;
				anchor: 'Anchor';
				yourself);
			yourself);
		yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEverythingEmbedded
	| wiki tree |
	wiki := '+Alias>' , self referenceString , '@Anchor+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText with: 'Alias');
				reference: self referenceString;
				anchor: 'Anchor';
				embedded: true;
				yourself);
			yourself);
		yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 11:45'!
testTitle
	super testTitle.
	self instance reference: 'page'.
	self assert: self instance title = 'page'! !

!PRLinkTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRLink! !

!PRLinkTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
referenceString
	self subclassResponsibility! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAlias
	self deny: self instance hasAlias.

	self instance add: self fooInstance.
	self assert: self instance hasAlias.
	self assert: self instance alias = 'foo'.

	self instance add: self barInstance.
	self assert: self instance hasAlias.
	self assert: self instance alias = 'foobar'! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAnchor
	self deny: self instance hasAnchor! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testEmbedded
	self instance embedded: true.
	self assert: self instance isEmbedded.

	self instance embedded: false.
	self deny: self instance isEmbedded! !

!PRLinkTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualEmbedded
	self deny: (self actualClass new embedded: false; yourself) = (self actualClass new embedded: true; yourself)! !

!PRLinkTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualReference
	self deny: (self actualClass new reference: 'foo'; yourself) = (self actualClass new reference: 'bar'; yourself)! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseAliased
	| wiki tree |
	wiki := '*Alias>' , self referenceString , '*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText with: 'Alias');
				reference: self referenceString;
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := '*' , self referenceString , '*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEasyness
	| wiki1 wiki2 tree |
	wiki1 := '*
*' , self referenceString.
	wiki2 := '\*
\*' , self referenceString.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '*');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '*' , self referenceString);
			yourself);
		yourself.

	self assertParsing: wiki1 gives: tree.
	self assertParsing: wiki2 gives: tree.
	self assertVisiting: tree gives: wiki2! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEasynessEmbedded
	| wiki1 wiki2 tree |
	wiki1 := '+
+' , self referenceString.
	wiki2 := '\+
\+' , self referenceString.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '+');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '+' , self referenceString);
			yourself);
		yourself.

	self assertParsing: wiki1 gives: tree.
	self assertParsing: wiki2 gives: tree.
	self assertVisiting: tree gives: wiki2! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEmbeddedAliased
	| wiki tree |
	wiki := '+Alias>' , self referenceString , '+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				add: (PRText with: 'Alias');
				reference: self referenceString;
				embedded: true;
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEmbeddedBasic
	| wiki tree |
	wiki := '+' , self referenceString , '+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (self actualClass new
				reference: self referenceString;
				embedded: true;
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEscaped
	| wiki tree |
	wiki := 'Star \*' , self referenceString , '\*
Cross \+' , self referenceString , '\+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Star *' , self referenceString , '*');
			yourself);
		add: (PRParagraph new
			add: (PRText with: 'Cross +' , self referenceString , '+');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testReference
	self instance reference: 'zork'.
	self assert: self instance reference = 'zork'! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2006 11:43'!
testTitle
	self deny: self instance title notNil! !

PRDocumentGroupTest subclass: #PRListItemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRListItemTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRListItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRListItem! !

PRDocumentGroupTest subclass: #PRListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRListTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRList! !

!PRListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
elementString
	self subclassResponsibility! !

!PRListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
listItemWithText: aString
	^ PRListItem new
		add: (PRText with: aString);
		yourself! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseFlat
	| wiki tree |
	wiki := self elementString , '1st
' , self elementString , '2nd
' , self elementString , '3rd'.
	tree := PRDocument new
		add: (self actualClass new
			add: (self listItemWithText: '1st');
			add: (self listItemWithText: '2nd');
			add: (self listItemWithText: '3rd');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseMixed
	| wiki tree |
	wiki := '#1
#2
-3'.
	tree := PRDocument new
		add: (PROrderedList new
			add: (self listItemWithText: '1');
			add: (self listItemWithText: '2');
			yourself);
		add: (PRUnorderedList new
			add: (self listItemWithText: '3');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseMultiple
	| wiki tree |
	wiki := self elementString , '1st
' , self elementString , '2nd

'
				, self elementString , '3rd'.
	tree := (PRDocument new)
				add: ((self actualClass new)
							add: (self listItemWithText: '1st');
							add: (self listItemWithText: '2nd');
							yourself);
				add: PRParagraph new;
				add: ((self actualClass new)
							add: (self listItemWithText: '3rd');
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseNested1
	| wiki tree |
	wiki := self elementString , '1
' , self elementString , self elementString , '1.1
' , self elementString , self elementString , '1.2'.
	tree := PRDocument new
		add: (self actualClass new
			add: (PRListItem new
				add: (PRText with: '1');
				add: (self actualClass new
					add: (self listItemWithText: '1.1');
					add: (self listItemWithText: '1.2');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseNested2
	| wiki tree |
	wiki := self elementString , '1
' , self elementString , self elementString , '1.1
' , self elementString , self elementString , self elementString , '1.1.1'.
	tree := PRDocument new
		add: (self actualClass new
			add: (PRListItem new
				add: (PRText with: '1');
				add: (self actualClass new
					add: (PRListItem new
						add: (PRText with: '1.1');
						add: (self actualClass new
							add: (self listItemWithText: '1.1.1');
							yourself);
						yourself);
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseNested3
	| wiki tree |
	wiki := self elementString , '1
' , self elementString , '#1.1
' , self elementString , '#1.2
' , self elementString , '-1.3'.
	tree := PRDocument new
		add: (self actualClass new
			add: (PRListItem new
				add: (PRText with: '1');
				add: (PROrderedList new
					add: (self listItemWithText: '1.1');
					add: (self listItemWithText: '1.2');
					yourself);
				add: (PRUnorderedList new
					add: (self listItemWithText: '1.3');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

PRListTest subclass: #PROrderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PROrderedListTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PROrderedListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PROrderedList! !

!PROrderedListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
elementString
	^ '#'! !

PRListTest subclass: #PRUnorderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRUnorderedListTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRUnorderedList! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
elementString
	^ '-'! !

PRDocumentGroupTest subclass: #PRParagraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRParagraphTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRParagraphTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRParagraph! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseClose
	| wiki tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.
Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.');
			yourself);
		add: (PRParagraph new
			add: (PRText with: 'Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSpare
	| wiki tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.

Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.');
			yourself);
		add: (PRParagraph new);
		add: (PRParagraph new
			add: (PRText with: 'Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

PRDocumentGroupTest subclass: #PRPreformattedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRPreformattedTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRPreformattedTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRPreformatted! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := '=Line'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: 'Line');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseMultiple
	| wiki tree |
	wiki := '=line 1.1
=line 1.2

=line 2.1'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: 'line 1.1');
			add: (PRText with: 'line 1.2');
			yourself);
		add: (PRParagraph new);
		add: (PRPreformatted new
			add: (PRText with: 'line 2.1');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSpaces
	| wiki tree |
	wiki := '=   A line with 3 spaces
=	A line with a tab'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: '   A line with 3 spaces');
			add: (PRText with: '	A line with a tab');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSpecials
	| wiki tree |
	wiki := '=|, {, }, *, *, [, ||, |{, |}, +, +'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: '|, {, }, *, *, [, ||, |{, |}, +, +');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

PRDocumentGroupTest subclass: #PRTableCellTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTableCellTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRTableCellTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRTableCell! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testAlign
	self instance align: #right.
	self assert: self instance align = #right! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testBeAlignedCenter
	self instance beAlignedCenter.
	self assert: self instance align = #center.
	self assert: self instance isAlignedCenter.
	self deny: self instance isAlignedLeft.
	self deny: self instance isAlignedRight! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testBeAlignedLeft
	self instance beAlignedLeft.
	self assert: self instance align = #left.
	self deny: self instance isAlignedCenter.
	self assert: self instance isAlignedLeft.
	self deny: self instance isAlignedRight! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testBeAlignedRight
	self instance beAlignedRight.
	self assert: self instance align = #right.
	self deny: self instance isAlignedCenter.
	self deny: self instance isAlignedLeft.
	self assert: self instance isAlignedRight! !

!PRTableCellTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualAlign
	self deny: self actualClass new beAlignedRight
				= self actualClass new beAlignedCenter.
	self deny: self actualClass new beAlignedCenter
				= self actualClass new beAlignedLeft! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseAlign1
	| wiki tree |
	wiki := '|{left||center|}right'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beAlignedLeft;
					add: (PRText with: 'left');
					yourself);
				add: (PRTableCell new
					beAlignedCenter;
					add: (PRText with: 'center');
					yourself);
				add: (PRTableCell new
					beAlignedRight;
					add: (PRText with: 'right');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseAlign2
	| wiki tree |
	wiki := '|}right|none|{left|none'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beAlignedRight;
					add: (PRText with: 'right');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'none');
					yourself);
				add: (PRTableCell new
					beAlignedLeft;
					add: (PRText with: 'left');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'none');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseEncoding
	| wiki tree |
	wiki := '|*link*|+embedded+|foo{}'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRInternalLink new
						reference: 'link';
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRInternalLink new
						reference: 'embedded';
						embedded: true;
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'foo{}');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

PRDocumentGroupTest subclass: #PRTableRowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTableRowTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRTableRowTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRTableRow! !

!PRTableRowTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testCount
	self instance add: PRTableCell new.
	self assert: self instance columnCount = 1.

	self instance add: PRTableCell new.
	self assert: self instance columnCount = 2! !

PRDocumentGroupTest subclass: #PRTableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTableTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRTableTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRTable! !

!PRTableTest methodsFor: 'testing-accessing' stamp: 'lr 3/21/2006 18:43'!
testCount
	self instance add: (PRTableRow new add: PRTableCell new; yourself).
	self assert: self instance rowCount = 1; assert: self instance columnCount = 1.

	self instance add: (PRTableRow new add: PRTableCell new; add: PRTableCell new; yourself).
	self assert: self instance rowCount = 2; assert: self instance columnCount = 2.

	self instance add: (PRTableRow new add: PRTableCell new; yourself).
	self assert: self instance rowCount = 3; assert: self instance columnCount = 2! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := '|cell'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'cell');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSquare
	| wiki tree |
	wiki := '|a11|a12
|a21|a22'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a11');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a12');
					yourself);
				yourself);
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a21');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a22');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseTriangle
	| wiki tree |
	wiki := '|a11
|a21|a22
|a31|a32|a33'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a11');
					yourself);
				yourself);
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a21');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a22');
					yourself);
				yourself);
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a31');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a32');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a33');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRDocumentItem! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualInstance
	^ self actualClass new! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:31'!
assertParsing: aString gives: anObject
	self
		assert: (PRDocumentParser parse: aString) = anObject
		description: aString resumable: true! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:31'!
assertVisiting: anObject gives: aString
	self
		assert: (PRDocumentWriter write: anObject) = aString
		description: aString resumable: true! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
barInstance
	^ PRText with: 'bar'! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
fooInstance
	^ PRText with: 'foo'! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
foobarInstances
	^ Array with: self fooInstance with: self barInstance! !

!PRDocumentItemTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ instance! !

!PRDocumentItemTest methodsFor: 'running' stamp: 'lr 3/9/2006 11:31'!
setUp
	super setUp.
	instance := self actualInstance! !

!PRDocumentItemTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopy
	self assert: self instance = self instance copy.
	self assert: self instance hash = self instance copy hash.

	self deny: self instance == self instance copy! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqueal
	self assert: self instance = self instance.
	self assert: self instance = self actualInstance! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEquealNil
	self deny: self instance isNil! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEquealOther
	self deny: self instance = self fooInstance.
	self deny: self instance = self barInstance! !

!PRDocumentItemTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasChildren
	self deny: self instance hasChildren! !

!PRDocumentItemTest methodsFor: 'testing-testing' stamp: 'lr 3/9/2006 11:31'!
testHasOwner
	self deny: self instance hasOwner! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testHash
	self assert: self instance hash = self instance copy hash! !

!PRDocumentItemTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testOwner
	self assert: self instance owner isNil! !

!PRDocumentItemTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testText
	self assert: self instance text isString! !

PRDocumentItemTest subclass: #PRHorizontalRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRHorizontalRuleTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRHorizontalRuleTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRHorizontalRule! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := '_'.
	tree := PRDocument new
		add: PRHorizontalRule new;
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 3/20/2006 17:48'!
testParseLink
	| wiki tree |
	wiki := '_ *link*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '_ ');
			add: (PRInternalLink new
				reference: 'link';
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseMultiple
	| wiki tree |
	wiki := '_
_

_'.
	tree := PRDocument new
		add: PRHorizontalRule new;
		add: PRHorizontalRule new;
		add: PRParagraph new;
		add: PRHorizontalRule new;
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseParagraph
	| wiki tree |
	wiki := '_ is parsed as paragraph'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '_ is parsed as paragraph');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSpaces
	| wiki tree |
	wiki := '_       '.
	tree := PRDocument new
		add: PRHorizontalRule new;
		yourself.

	self assertParsing: wiki gives: tree! !

PRDocumentItemTest subclass: #PRTextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTextTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRTextTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRText! !

!PRTextTest methodsFor: 'testing-comparing' stamp: 'lr 3/9/2006 11:31'!
testEqualText
	self deny: (self actualClass with: 'foo') = (self actualClass with: 'bar')! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testEscapeFirst
	| wiki tree |
	wiki := '\* text
\+ text
\= text
\@ text
\!! text
\| text
\# text
\- text'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '* text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '+ text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '= text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '@ text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '!! text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '| text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '# text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '- text');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testEscapeStrange
	| wiki tree |
	wiki := '< text
> text'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '< text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '> text');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testEscapeText
	| wiki tree |
	wiki := 'Text: \*\+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Text: *+');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testEscapeWiki
	| wiki tree |
	wiki := 'Wiki: =, |, !!, #, {, }, |{, ||, |}, [, ] and -'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Wiki: =, |, !!, #, {, }, |{, ||, |}, [, ] and -');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseBasic
	| wiki tree |
	wiki := 'abcdefghijklmnopqrstuvwxyz... ABCDEFGHIJKLMNOPQRSTUVWXYZ... 0123456789...'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'abcdefghijklmnopqrstuvwxyz... ABCDEFGHIJKLMNOPQRSTUVWXYZ... 0123456789...');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseHtml
	| wiki tree |
	wiki := '<strong>strong <emph>strong, emph</emph></strong>'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '<strong>strong <emph>strong, emph</emph></strong>');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseLatex
	| wiki tree |
	wiki := '\begin{foo}[bar]$zork$\end{foo}'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '\begin{foo}[bar]$zork$\end{foo}');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseSpecial
	| wiki tree |
	wiki := '????????????????????????????????Ƭج????????ĦŦǦɦѦ֦ܦ????ߦƦ???'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '????????????????????????????????Ƭج????????ĦŦǦɦѦ֦ܦ????ߦƦ???');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 3/9/2006 11:31'!
testParseWiki
	| wiki tree |
	wiki := ' !!_#-|=]@:<>\*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: ' !!_#-|=]@:<>*');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRTextTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testText
	self instance text: 'zork'.
	self assert: self instance text = 'zork'! !

!PRTextTest methodsFor: 'testing-instantiation' stamp: 'lr 3/9/2006 11:31'!
testWith
	instance := self actualClass with: 'zork'.
	self assert: self instance text = 'zork'! !

PRObjectTest subclass: #PRKernelTest
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Kernel'!

!PRKernelTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PRKernelTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRKernel! !

!PRKernelTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	^ self kernel! !

!PRKernelTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ]! !

!PRKernelTest methodsFor: 'testing' stamp: 'lr 3/21/2006 18:43'!
testInitialState
	self deny: self kernel mutex isNil.
	self deny: self kernel name isNil.
	self deny: self kernel persistency isNil.
	self deny: self kernel root isNil! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 3/9/2006 11:31'!
testMutexError
	"An error inside the critical section should properly unlock it for others to enter."

	| marker |
	marker := nil.
	self
		should: [ self kernel critical: [ Error signal ] ]
		raise: Error.

	self kernel critical: [ marker := 1 ].
	self assert: marker = 1! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 3/9/2006 11:31'!
testMutexForked
	"Two different processed are not allowed to be inside the critical section at once."

	| in1 sem1 in2 sem2  |
	in1 := false.
	in2 := false.

	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[ self kernel critical: [ in1 := true. sem1 signal. sem2 wait ] ] fork.
	[ self kernel critical: [ in2 := true. sem1 signal. sem2 wait ] ] fork.

	sem1 wait.
	self deny: in1 = in2.
	sem2 signal.

	sem1 wait.
	self assert: in1 = in2.
	sem2 signal! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 3/9/2006 11:31'!
testMutexNested
	"Critical sections should be nestable to any level within one process."

	| marker |
	marker := nil.

	self kernel critical: [
		self kernel critical: [
			marker := 1 ] ].
	self assert: marker = 1.

	self kernel critical: [
		self kernel critical: [
			self kernel critical: [
				marker := 2 ] ] ].
	self assert: marker = 2! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 3/9/2006 11:31'!
testMutexSimple
	| marker |
	marker := nil.
	self kernel critical: [ marker := 1 ].
	self assert: marker = 1! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testName
	self kernel name: 'kernel'.
	self assert: self kernel name = 'kernel'! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testPersistency
	| persistency |
	self kernel persistency: (persistency := PRNullPersistency new).
	self assert: self kernel persistency = persistency.
	self assert: self kernel = persistency kernel! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 3/9/2006 11:31'!
testRoot
	| structure |
	self kernel root: (structure := PRPage new).
	self assert: self kernel root = structure! !

!PRObjectTest class methodsFor: 'building' stamp: 'lr 3/9/2006 11:31'!
buildTestClassFor: aClass
	" self buildTestClassFor: PRObject "

	| thisName thisClass thisCategory parentClass |
	thisName := (aClass name , 'Test') asSymbol.
	(thisName beginsWith: 'PR')
		ifFalse: [ ^ self ].
	thisClass := MACompatibility classNamed: thisName.
	thisCategory := 'Pier-Tests-' , (aClass category copyAfterLast: $-).
	parentClass := self = thisClass
		ifTrue: [ self superclass ]
		ifFalse: [ Smalltalk classNamed: (aClass superclass name , 'Test') asSymbol ].
	thisClass := parentClass
		subclass: thisName
		instanceVariableNames: (thisClass isNil
			ifFalse: [ thisClass instanceVariablesString ]
			ifTrue: [ String new ])
			classVariableNames: ''
			poolDictionaries: ''
			category: thisCategory.
	thisClass
		compile: 'actualClass
	^ ' , aClass name
		classified: #private.
	thisClass class
		compile: 'isAbstract
	^ ' , aClass isAbstract asString
		classified: #testing.
	aClass subclassesDo: [ :each | self buildTestClassFor: each ]! !

!PRObjectTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ true! !

!PRObjectTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
shouldInheritSelectors
	^ true! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PRObject! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
contextInstance
	^ PRContext kernel: self kernelInstance! !

!PRObjectTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:31'!
instance
	self subclassResponsibility! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
kernelInstance
	^ PRKernel new
		name: 'test';
		root: self rootInstance;
		persistency: self persistencyInstance;
		yourself! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
persistencyInstance
	^ PRNullPersistency new! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
rootInstance
	^ (PRPage named: 'root')
		addChild: ((PRPage named: 'folder')
			addChild: (PRPage named: 'child');
			addChild: (self structureInstance);
			yourself);
		yourself! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
structureInstance
	^ PRPage named: 'structure'! !

!PRObjectTest methodsFor: 'testing-copying' stamp: 'lr 3/9/2006 11:31'!
testCopyProperties
	self assert: self instance properties = self instance copy properties.
	self deny: self instance properties == self instance copy properties! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testProperties
	self assert: self instance properties notNil.
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo put: #bar.
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo ifAbsent: [ nil ].
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo ifAbsentPut: [ #bar ].
	self instance instVarNamed: 'properties' put: nil.

	self instance hasProperty: #foo.
	self instance instVarNamed: 'properties' put: nil! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAt
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.
	self should: [ self instance propertyAt: #bar ] raise: Error! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAtIfAbsent
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (self instance propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAtIfAbsentPut
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo ifAbsentPut: [ 'baz' ]) = 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.

	self assert: (self instance propertyAt: #bar ifAbsentPut: [ 'baz' ]) = 'baz'.
	self assert: (self instance propertyAt: #bar) = 'baz'! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesAtPut
	self instance propertyAt: #foo put: 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.

	self instance propertyAt: #foo put: 'baz'.
	self assert: (self instance propertyAt: #foo) = 'baz'! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 3/9/2006 11:31'!
testPropertiesHas
	self deny: (self instance hasProperty: #foo).
	self instance propertyAt: #foo put: 'bar'.
	self assert: (self instance hasProperty: #foo).
	self deny: (self instance hasProperty: #bar)! !

!PRObjectTest methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
testSanity
	"If this test case fails, there is something wrong with the setup of the test-case."

	self
		assert: self actualClass isAbstract not
		description: 'Unable to test abstract class.'.
	self
		assert: self instance class = self actualClass
		description: 'Invalid test instance.'! !

TestCase subclass: #PRUtilitiesTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Utilities'!

!PRUtilitiesTests methodsFor: 'testing-escaper' stamp: 'lr 10/30/2006 19:49'!
testEnsureEscape
	| visitor tag |
	visitor := PRVisitor new.
	tag := nil.

	self assert: (visitor withEscaper: [
		[ true ]
			ensure: [ tag := 1 ] ]).
	self assert: tag = 1.

	self assert: (visitor withEscaper: [
		[ visitor escape: true ]
			ensure: [ tag := 2 ] ]).
	self assert: tag = 2! !

!PRUtilitiesTests methodsFor: 'testing-escaper' stamp: 'lr 10/30/2006 19:49'!
testEscaper
	| visitor |
	visitor := PRVisitor new.
	
	self assert: (visitor withEscaper: [ true ]).
	self deny: (visitor withEscaper: [ false ]).

	self assert: (visitor withEscaper: [ visitor escape: true. false ]).
	self deny: (visitor withEscaper: [ visitor escape: false. true ])! !

!PRUtilitiesTests methodsFor: 'testing-escaper' stamp: 'lr 10/30/2006 19:49'!
testHasEscaper
	| visitor |
	visitor := PRVisitor new.
	self deny: visitor hasEscaper.
	self assert: (visitor withEscaper: [ visitor hasEscaper ])! !

!PRUtilitiesTests methodsFor: 'testing-expander' stamp: 'lr 3/9/2006 11:31'!
testMacroInitialized
	| expander |
	expander := PRMacroExpander new.

	self assert: expander character = $%.
	self assert: expander default notNil.
	self assert: expander table isEmpty! !

!PRUtilitiesTests methodsFor: 'testing-expander' stamp: 'lr 3/9/2006 11:31'!
testMacroValue
	| expander |
	expander := PRMacroExpander new.
	expander table
		at: $1 put: [ '!!1' ];
		at: $2 put: [ '!!2' ].

	self assert: (expander value: '') = ''.
	self assert: (expander value: 'xyz') = 'xyz'.

	self assert: (expander value: '%1') = '!!1'.
	self assert: (expander value: '%2') = '!!2'.

	self assert: (expander value: '%1xy') = '!!1xy'.
	self assert: (expander value: 'x%1y') = 'x!!1y'.
	self assert: (expander value: 'xy%1') = 'xy!!1'.

	self assert: (expander value: '%2xy') = '!!2xy'.
	self assert: (expander value: 'x%2y') = 'x!!2y'.
	self assert: (expander value: 'xy%2') = 'xy!!2'.

	self assert: (expander value: '%1%2') = '!!1!!2'.
	self assert: (expander value: 'x%1%2') = 'x!!1!!2'.
	self assert: (expander value: 'x%1y%2') = 'x!!1y!!2'.
	self assert: (expander value: 'x%1y%2z') = 'x!!1y!!2z'.

	self assert: (expander value: '%%') = '%'.
	self assert: (expander value: '%3') = '%3'! !

!PRUtilitiesTests methodsFor: 'testing-expander' stamp: 'lr 3/9/2006 11:31'!
testMacroValueValue
	| expander |
	expander := PRMacroExpander new.
	expander table
		at: $1 put: [ :char | '!!' , char asString ];
		at: $2 put: [ :char | '!!' , char asString ].

	self assert: (expander value: '') = ''.
	self assert: (expander value: 'xyz') = 'xyz'.

	self assert: (expander value: '%1') = '!!1'.
	self assert: (expander value: '%2') = '!!2'.

	self assert: (expander value: '%1xy') = '!!1xy'.
	self assert: (expander value: 'x%1y') = 'x!!1y'.
	self assert: (expander value: 'xy%1') = 'xy!!1'.

	self assert: (expander value: '%2xy') = '!!2xy'.
	self assert: (expander value: 'x%2y') = 'x!!2y'.
	self assert: (expander value: 'xy%2') = 'xy!!2'.

	self assert: (expander value: '%1%2') = '!!1!!2'.
	self assert: (expander value: 'x%1%2') = 'x!!1!!2'.
	self assert: (expander value: 'x%1y%2') = 'x!!1y!!2'.
	self assert: (expander value: 'x%1y%2z') = 'x!!1y!!2z'.

	self assert: (expander value: '%%') = '%'.
	self assert: (expander value: '%3') = '%3'! !

!PRUtilitiesTests methodsFor: 'testing-expander' stamp: 'lr 3/9/2006 11:31'!
testMacroValueValueValue
	| expander |
	expander := PRMacroExpander new.
	expander table
		at: $1 put: [ :char :arg | arg , char asString ];
		at: $2 put: [ :char :arg | arg , char asString ].

	self assert: (expander value: '') = ''.
	self assert: (expander value: 'xyz') = 'xyz'.

	self assert: (expander value: '%1' value: '!!') = '!!1'.
	self assert: (expander value: '%2' value: '!!') = '!!2'.

	self assert: (expander value: '%1xy' value: '!!') = '!!1xy'.
	self assert: (expander value: 'x%1y' value: '!!') = 'x!!1y'.
	self assert: (expander value: 'xy%1' value: '!!') = 'xy!!1'.

	self assert: (expander value: '%2xy' value: '!!') = '!!2xy'.
	self assert: (expander value: 'x%2y' value: '!!') = 'x!!2y'.
	self assert: (expander value: 'xy%2' value: '!!') = 'xy!!2'.

	self assert: (expander value: '%1%2' value: '!!') = '!!1!!2'.
	self assert: (expander value: 'x%1%2' value: '!!') = 'x!!1!!2'.
	self assert: (expander value: 'x%1y%2' value: '!!') = 'x!!1y!!2'.
	self assert: (expander value: 'x%1y%2z' value: '!!') = 'x!!1y!!2z'! !

TestCase subclass: #PRVisitorTests
	instanceVariableNames: 'visitor root folder child1 child2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Utilities'!

!PRVisitorTests methodsFor: 'running' stamp: 'lr 10/30/2006 19:51'!
setUp
	root := PRPage named: 'root'.
	folder := PRPage named: 'folder'.
	child1 := PRPage named: 'child1'.
	child2 := PRPage named: 'child2'.
	
	root addChild: folder.
	folder addChild: child1.
	folder addChild: child2! !

!PRVisitorTests methodsFor: 'testing-incoming' stamp: 'lr 10/30/2006 20:34'!
testIncomingReferencesMultiple
	| matched |
	root contents: '*folder*'.
	folder contents: '*child1* *child2*'.
	child1 contents: '*/*'.
	child2 contents: ''.

	matched := root incomingReferences
		toAll: (Array with: root with: folder);
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'root' 'child1' ).
	matched := folder incomingReferences
		toAll: (Array with: root with: folder);
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'child1' ).
	matched := folder incomingReferences
		toAll: (Array with: child1 with: child2);
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'folder' 'folder' )! !

!PRVisitorTests methodsFor: 'testing-incoming' stamp: 'lr 10/30/2006 20:29'!
testIncomingReferencesSingle
	| matched |
	root contents: '*folder*'.
	folder contents: '*child1* *child2*'.
	child1 contents: '*/*'.
	child2 contents: ''.
	
	matched := root incomingReferences
		to: root;
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'child1' ).
	matched := root incomingReferences 
		to: folder;
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'root' ).
	matched := root incomingReferences
		to: child1;
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'folder' ).
	matched := root incomingReferences 
		to: child2;
		collect: [ :each | each owner ].
	self assert: (matched collect: #name) = #( 'folder' )! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'lr 10/30/2006 20:07'!
testOutgoingReferencesContinue
	| matched |
	root contents: '+folder+'.
	folder contents: '+child1+ +child2+'.
	child1 contents: '+/+'.
	child2 contents: ''.
	
	matched := root outgoingReferences 
		continue: [ :each | false ];
		collect: #target.
	self assert: (matched collect: #name) = #( 'folder' ).
	matched := root outgoingReferences 
		continue: [ :each | each owner = root ];
		collect: #target.
	self assert: (matched collect: #name) = #( 'folder' 'child1' 'child2' ).
	matched := root outgoingReferences 
		continue: [ :each | each target ~= child1 ];
		collect: #target.
	self assert: (matched collect: #name) = #( 'folder' 'child1' 'child2' )! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'lr 10/30/2006 20:03'!
testOutgoingReferencesEmbedded
	| matched |
	root contents: '+folder+'.
	folder contents: '+child1+ +child2+'.
	child1 contents: '+/+'.
	child2 contents: ''.
	
	matched := root outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( 'folder' 'child1' 'root' 'child2' ).
	matched := folder outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( 'child1' 'root' 'folder' 'child2' ).
	matched := child1 outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( 'root' 'folder' 'child1' 'child2' ).
	matched := child2 outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( )! !

!PRVisitorTests methodsFor: 'testing-outgoing' stamp: 'lr 10/30/2006 20:02'!
testOutgoingReferencesStandard
	| matched |
	root contents: '*folder*'.
	folder contents: '*child1* *child2*'.
	child1 contents: '*/*'.
	child2 contents: ''.
	
	matched := root outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( 'folder' ).
	matched := folder outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( 'child1' 'child2' ).
	matched := child1 outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( 'root' ).
	matched := child2 outgoingReferences collect: #target.
	self assert: (matched collect: #name) = #( )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 10/30/2006 20:23'!
testSearchCaseSensitive
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.
	
	match := root fullTextSearch subString: 'Bar'; caseSensitive: true.
	self assert: (match collect: #name) = #( ).
	match := root fullTextSearch subString: 'bar'; caseSensitive: true.
	self assert: (match collect: #name) = #( 'folder' ).
	
	match := root fullTextSearch subString: 'Bar'; caseSensitive: false.
	self assert: (match collect: #name) = #( 'folder' ).
	match := root fullTextSearch subString: 'bar'; caseSensitive: false.
	self assert: (match collect: #name) = #( 'folder' ).
	
	match := root fullTextSearch subString: 'Bar'.
	self assert: (match collect: #name) = #( 'folder' ).
	match := root fullTextSearch subString: 'bar'.
	self assert: (match collect: #name) = #( 'folder' )
! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 10/30/2006 20:23'!
testSearchContents
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.
		
	match := root fullTextSearch subString: 'foo'.
	self assert: (match collect: #name) = #( 'root' ).
	match := root fullTextSearch subString: 'bar'.
	self assert: (match collect: #name) = #( 'folder' ).
	match := root fullTextSearch subString: 'zork'.
	self assert: (match collect: #name) = #( 'child1' ).
	match := root fullTextSearch subString: 'plonk'.
	self assert: (match collect: #name) = #( 'child2' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 10/30/2006 20:23'!
testSearchMultiple
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.
		
	match := root fullTextSearch subString: '1'.
	self assert: (match collect: #name) = #( 'root' 'child1' ).
	match := root fullTextSearch subString: '2'.
	self assert: (match collect: #name) = #( 'folder' 'child2' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 10/30/2006 20:23'!
testSearchNonRoot
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.
	
	match := root fullTextSearch subString: 'plonk'.
	self assert: (match collect: #name) = #( 'child2'  ).	
	match := folder fullTextSearch subString: 'plonk'.
	self assert: (match collect: #name) = #( 'child2'  ).
	match := child1 fullTextSearch subString: 'plonk'.
	self assert: (match collect: #name) = #(  ).
	match := child2 fullTextSearch subString: 'plonk'.
	self assert: (match collect: #name) = #( 'child2' )! !

!PRVisitorTests methodsFor: 'testing-search' stamp: 'lr 10/30/2006 20:23'!
testSearchTitle
	| match |
	root contents: 'struct 1 foo'.
	folder contents: 'struct 2 bar'.
	child1 contents: 'struct 3 zork'.
	child2 contents: 'struct 4 plonk'.
		
	match := root fullTextSearch subString: 'root'.
	self assert: (match collect: #name) = #( 'root' ).
	match := root fullTextSearch subString: 'folder'.
	self assert: (match collect: #name) = #( 'folder' ).
	match := root fullTextSearch subString: 'child1'.
	self assert: (match collect: #name) = #( 'child1' ).
	match := root fullTextSearch subString: 'child2'.
	self assert: (match collect: #name) = #( 'child2' )! !
